!ABCIncludeFile

OMIT('_EndOfInclude_',_hOLEClPresent_)
_hOLEClPresent_ EQUATE(1)

!Other Classes
  include('StrCl.inc')

!Equates - will be seen by using program
eDebugLabelLen equate(80)
VtableQType  Queue,type
VtableID       Long
pVtable        Long
  end

IIDQType       Queue,Type    !pairs an interface with its IID - use in advanced erro
eInterface      long
IID_Address     long
InterfaceName   string(eDebugLabelLen)
   end
MethodNameQType queue,type
eMethod         long
MethodName      string(eDebugLabelLen)
  end

eDebugVerbose  equate(2) !debug mode reports success as well as failure
eDebugError    equate(1) !debug mode reports only errors
edebugOff      equate(0) !no debug messages

!equates for cocreateinstance
CLSCTX_INPROC_SERVER        Equate(1)
CLSCTX_INPROC_HANDLER       Equate(2)
CLSCTX_LOCAL_SERVER         Equate(4)
CLSCTX_INPROC_SERVER16      Equate(8)
CLSCTX_REMOTE_SERVER        Equate(10H)
CLSCTX_INPROC_HANDLER16     Equate(20H)
CLSCTX_INPROC_SERVERX86     Equate(40H)
CLSCTX_INPROC_HANDLERX86    Equate(80H)
CLSCTX_ALL EQUATE(17H) !INPROC_SERVER+INPROC_HANDLER+LOCAL_SERVER+REMOTE_SERVER

!IUnknown Methods
MethodOffsetMask           Equate(0FFH)
InterfaceShift             Equate(-8)
eQueryInterface            Equate(0)
eAddRef                    Equate(4)
eRelease                   Equate(8)


!Error interfaces
  Itemize(1)
eIMalloc                   equate
eIErrorRecords             equate
eIErrorInfo                equate
eISupportErrorInfo         equate
eIErrorInfoRec             equate  !is really the same as IErrorInfo but need two instances
eISQLServerErrorInfo       equate
            end

!Methods
eIMallocFree                equate(eIMalloc*100H        + 14H)   !IMalloc
eGetBasicErrorInfo          Equate(eIErrorRecords*100H  + 10H)   !IErrorRecords
eGetCustomErrorObject       Equate(eIErrorRecords*100H  + 14H)   !IErrorRecords
eGetErrorInfo               equate(eIErrorRecords*100H  + 18H)   !IErrorRecords
eGetErrorParameters         equate(eIErrorRecords*100H  + 1CH)   !IErrorRecords
eGetRecordCount             equate(eIErrorRecords*100H  + 20H)   !IErrorRecords
eInterfaceSupportsErrorInfo Equate(eISupportErrorInfo*100H+0CH)  !ISupportErrorInfo
eGetDescription             Equate(eIErrorInfoRec*100H  + 14H)   !IErrorInfoRec
eGetSource                  Equate(eIErrorInfoRec*100H  + 10H)   !IErrorInfoRec
eSqlGetErrorInfo            Equate(eISQLServerErrorInfo*100H+0CH) !ISQLServerErrorInfo

hOleClType Class,type,module('hOleCl.CLW'),LINK('hOleCl.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)

!Member Data
StrCl           &StrClType
VtableQ         &VTableQType
IIDQ            &IIDQType
MethodNameQ     &MethodNameQType
DebugMode       byte
LastError       long
LastSQLError    long

!Methods - all return 0 for success if they return anything
Init                Procedure(byte pDebugMode=0),byte,proc
KILL                Procedure()
ReleaseAll          Procedure()      !Release all acquired interfaces
CoCreate            Procedure(long pCLSID, long pVtableID),byte,proc
CoGetObject         Procedure(long pCLSID, long pVtableID),byte,proc
CoGetObjectFromFile Procedure(long pCLSID, long pVtableID, STRING FileName),byte,proc
AddVtable           Procedure(long pVtableID, long ppVtable),byte,proc                  !Adds the pVtable to the vtableQ
Failed              Procedure(long phr,String pfn, long eInterface, long eMethod),byte  !checks for error and displays a messages based on debugmode setting.
ICall               Procedure(long parameterCount, long eInterface, long eMethod, long p1=0, long p2=0, long p3=0, long p4=0, long p5=0, long p6=0, long p7=0, long p8=0, long p9=0),byte,proc
QueryInterface      Procedure(long ppVtableToQuery, Long pIID, long pVtableID),byte,proc
GetVtable           Procedure(long pVtableID),Long               !Returns the pVtable for the VtableID passed, On error pVtable is 0 and VtableID is also 0 if entry was not found
Release             Procedure(long eInterface),byte,proc         !Deletes VtableQ entry after calling the release method. Done automatically by Kill
AddRef              Procedure(long eInterface),byte,proc
RoundUp8            Procedure(long pInVal),long                  !Rounds the value passed up to the next even multiple of 8 - para align data
SetDebugMode        Procedure(byte pDBM) !0,1,2
GetLastError        Procedure(),long
GetMethodName       Procedure(long eMethod),String
GetInterfaceName    Procedure(long eInterface),string
AdvancedError       Procedure(long pHR, string pfn,long eInterface, long eMethod),byte
GetIIDOf            Procedure(Long pInterface),long
AddIID              Procedure(Long pInterface, long pIID_Address, String InterfaceName)
AddMethodName       Procedure(Long eMethodName, string MethodName)
    end


 !_EndOfInclude_