    MEMBER()

_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

    INCLUDE('MSWORD8.INC')
    INCLUDE('VARCL.INC')

    MAP
      MODULE('Windows')
       SysFreeString(LONG),LONG,PASCAL,PROC
       OleRun(LONG),LONG,PASCAL,PROC
      END
    END

!global data for this module
Return:benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)

!Equates for Interfaces
!1-19 is reserved for hOleCl interfaces
    ITEMIZE(20)
    !List all interfaces called here
IUnknown         EQUATE
IWordObject      EQUATE
IWordApplication EQUATE
    END

!Vtable Offset - List all methods called
IWordApplication_Name           EQUATE(IWordApplication*100H +  4*4      + 24)
IWordApplication_Visible        EQUATE(IWordApplication*100H + 28*4      + 24)


! IWordApplicationObject
!  uuid(000209FF-0000-0000-C000-000000000046),
CLSID_WordObject  GROUP
data1       ULONG(000209FFH)
data2       USHORT(0000H)
data3       USHORT(0000H)
data41      BYTE(0C0H)
data42      BYTE(000H)
data43      BYTE(000H)
data44      BYTE(000H)
data45      BYTE(000H)
data46      BYTE(000H)
data47      BYTE(000H)
data48      BYTE(046H)
  END

! IUnknown
! uuid(00000000-0000-0000-C000-000000000046),
IID_IUnknown   GROUP
data1       ULONG(00000000H)
data2       USHORT(0000H)
data3       USHORT(0000H)
data41      BYTE(0C0H)
data42      BYTE(000H)
data43      BYTE(000H)
data44      BYTE(000H)
data45      BYTE(000H)
data46      BYTE(000H)
data47      BYTE(000H)
data48      BYTE(046H)
  END

! IWordApplication
!  uuid(00020970-0000-0000-C000-000000000046),
IID_WordApplication  GROUP
data1       ULONG(00020970H)
data2       USHORT(0000H)
data3       USHORT(0000H)
data41      BYTE(0C0H)
data42      BYTE(000H)
data43      BYTE(000H)
data44      BYTE(000H)
data45      BYTE(000H)
data46      BYTE(000H)
data47      BYTE(000H)
data48      BYTE(046H)
  END

!-----------------------------------------------------------------------------!
!   WordClass                                                                 !
!-----------------------------------------------------------------------------!

WordClass.Init    PROCEDURE(byte pDebugMode=0) !,byte,proc
Res     BYTE,AUTO
pVtable LONG
  CODE
  CLEAR(SELF)
  res = Parent.Init(pDebugMode)
  IF ~Res THEN
    SELF.AddIID(IUnknown,ADDRESS(IID_IUnknown),'IUnknown')
    SELF.AddIID(IWordApplication,ADDRESS(IID_WordApplication),'IWordApplication')
    
    SELF.AddMethodName(IWordApplication_Name,   'IWordApplication_Name')
    SELF.AddMethodName(IWordApplication_Visible,'IWordApplication_Visible')

    IF SELF.CoCreate(ADDRESS(CLSID_WordObject), IUnknown) THEN RETURN(Return:Fatal).

    pVtable = SELF.GetVtable(IUnknown)
    OleRun(pVtable)

    !Get IWordApplication from QueryInterface
    If SELF.QueryInterface(IUnknown, Address(IID_WordApplication), IWordApplication ) then Return(Return:Fatal).

  END
  RETURN(Res)

WordClass.GetName     PROCEDURE()
ReturnValue   STRING(512),AUTO
lpBstr        LONG(0)
  CODE

  IF ~SELF.ICall(1, IWordApplication, IWordApplication_Name, ADDRESS(lpBstr))
    IF SELF.StrCl.BSTRToCWStr(lpBstr,ReturnValue) THEN
      CLEAR(ReturnValue)
    END
  END
  IF lpBstr THEN SysFreeString(lpBstr) .

  RETURN(ReturnValue)

WordClass.SetVisible     PROCEDURE(BYTE OnOff)
Var           VariantCl
  CODE
  SELF.ICall(1, IWordApplication, IWordApplication_Visible, Var.Init(OnOff,VT_BOOL))

